

<% if (question.type_name.toUpperCase().indexOf('C-LANG') >= 0 || question.type_name.toUpperCase().indexOf('JAVA') >= 0 || question.type_name.toUpperCase().indexOf('CODE') >= 0) { %>
    <input name="c_question_answer_id" hidden value=<%= code_question_answer.id %>>
    <input name="programming_languages" hidden value=<%= programming_languages.map(language => language.id) %>>

    <% if (show_rtc) { %>
        <div class="row p-2 card-body card mt-2 mb-2" id="accordion" role="tablist"
             aria-multiselectable="true">            
            <div class="card">
                <div class="card-header" role="tab" id="question-constraints">
                    <h5 class="mb-0">
                        <a data-toggle="collapse" data-parent="#accordionRight" href="#collapseOneConstraints"
                            aria-expanded="true"
                            aria-controls="collapseOneConstraints">
                            <% let hasQuestionOverride = code_question_rtc.map(item => item.override_level).includes('question') %>

                            <span>
                                Runtime Constraints
                                <% if(hasQuestionOverride) { %>
                                    <i class="fas fa-exclamation fa-sm" style="margin-left: 5px"></i>
                                <% } %>
                            </span>
                        </a>
                    </h5>
                </div>

                <div id="collapseOneConstraints" class="collapse" role="tabpanel"
                        aria-labelledby="question-constraints">
                    <div class="card-body">
                        <div class="container-fluid">
                            <ul class="nav nav-tabs" id="question-constraints-tab" role="tablist">
                                <% for(let i = 0; i < programming_languages.length; i++) { %>
                                    <% let hasLanguageOverride =
                                    code_question_rtc.filter(item => item.programming_language_id === programming_languages[i].id)
                                            .map(item => item.override_level).includes('question') %>
                                    <li class="nav-item">
                                        <a class="nav-link <%- (i === 0) ? 'active' : '' %>"
                                            id="question-constraints-tab-<%= programming_languages[i].id %>"
                                            data-toggle="tab"
                                            href="#question-constraints-panel-<%= programming_languages[i].id %>"
                                            role="tab"
                                            aria-controls="question-constraints-panel-<%= programming_languages[i].id %>"
                                            aria-selected="true">
                                            <span>
                                                    <%- programming_languages[i].name %>
                                                <% if(hasLanguageOverride) { %>
                                                    <i class="fas fa-exclamation fa-sm" style="margin-left: 5px"></i>
                                                <% } %>
                                            </span>
                                        </a>
                                    </li>
                                <% } %>
                            </ul>
                            <div class="tab-content" id="question-constraints-tab-content">
                                <% for(let i = 0; i < programming_languages.length; i++) { %>
                                    <div class="tab-pane fade collapse <%- (i === 0) ? 'show active' : '' %>"
                                            id="question-constraints-panel-<%= programming_languages[i].id %>"
                                            role="tabpanel"
                                            aria-labelledby="question-constraints-tab-<%= programming_languages[i].id %>"
                                            aria-selected="<%- (i === 0) ? 'true' : 'false' %>">
                                        <div class="card-body">
                                            <table class="table table-hover edgar no-dt">
                                                <thead>
                                                <tr>
                                                    <th scope="col">#</th>
                                                    <th scope="col">constraint</th>
                                                    <th scope="col">value</th>
                                                    <th scope="col">current value</th>
                                                </tr>
                                                </thead>
                                                <tbody>
                                                <% let currentLanguageArr = code_question_rtc.filter(item => item.programming_language_id === programming_languages[i].id) %>
                                                <% for(let j = 0; j < currentLanguageArr.length; j++) { %>
                                                    <tr>
                                                        <th scope="row"><%- (j + 1) %></th>
                                                        <td><%- currentLanguageArr[j].constraint_name %></td>
                                                        <% if(currentLanguageArr[j].j0_unit_type) { %>
                                                            <% if(currentLanguageArr[j].j0_unit_type === 'second') { %>
                                                                <td><input class="form-control" placeholder="..."
                                                                            type="number" min="0" 
                                                                            step="0.001"
                                                                            name="rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>"
                                                                            value="<%- currentLanguageArr[j].override_level === 'question' ? currentLanguageArr[j].constraint_value : '' %>">
                                                                </td>
                                                            <% } else if(currentLanguageArr[j].j0_unit_type === 'kilobyte') { %>
                                                                <td><input class="form-control" placeholder="..."
                                                                            type="number" min="0" 
                                                                            step="1"
                                                                            name="rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>"
                                                                            value="<%- currentLanguageArr[j].override_level === 'question' ? currentLanguageArr[j].constraint_value : '' %>">
                                                                </td>
                                                            <% } %>
                                                        <% } else { %>
                                                            <% if(currentLanguageArr[j].constraint_value === 'true' || currentLanguageArr[j].constraint_value === 'false') { %>
                                                                <td>
                                                                    <div class="form-check form-check-inline">
                                                                        <input class="form-check-input" type="radio"
                                                                                name="rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>"
                                                                                id="input_true_rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>"
                                                                                value="true" <%- (currentLanguageArr[j].override_level === 'question' && currentLanguageArr[j].constraint_value === 'true') ? 'checked' : '' %> >
                                                                        <label class="form-check-label"
                                                                                for="input_true_rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>">true</label>
                                                                    </div>
                                                                    <div class="form-check form-check-inline">
                                                                        <input class="form-check-input" type="radio"
                                                                                name="rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>"
                                                                                id="input_false_rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>"
                                                                                value="false"
                                                                                <%- (currentLanguageArr[j].override_level === 'question' && currentLanguageArr[j].constraint_value === 'false') ? 'checked' : '' %>>
                                                                        <label class="form-check-label"
                                                                                for="input_false_rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>">false</label>
                                                                    </div>
                                                                    <div class="form-check form-check-inline">
                                                                        <input class="form-check-input" type="radio"
                                                                                name="rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>"
                                                                                id="input_none_rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>"
                                                                                value=""
                                                                                <%- (currentLanguageArr[j].override_level !== 'question') ? 'checked' : '' %>>
                                                                        <label class="form-check-label"
                                                                                for="input_none_rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>">default</label>
                                                                    </div>
                                                                </td>
                                                            <% } else { %>
                                                                <td><input class="form-control" placeholder="..."
                                                                            type="number" min="0" 
                                                                            step="1"
                                                                            name="rtc_q_lang_<%- programming_languages[i].id %>_constr_<%- currentLanguageArr[j].constraint_id %>"
                                                                            value="<%- currentLanguageArr[j].override_level === 'question' ? currentLanguageArr[j].override_value : '' %>">
                                                                </td>
                                                            <% } %>
                                                        <% } %>
                                                        <td><%- currentLanguageArr[j].constraint_value %> <%- currentLanguageArr[j].j0_unit_type ? currentLanguageArr[j].j0_unit_type + 's' : '' %></td>
                                                    </tr>
                                                <% } %>
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                <% } %>
                            </div>

                        </div>
                    </div>
                </div>
            </div>
            
        </div>
    <% } %>
    
    <div class="row p-2 card-body card" id="accordionRight" role="tablist"
         aria-multiselectable="true">
        <div class="card mb-1">
            <div class="card-header" role="tab" id="headingOne">
                <h5 class="mb-0">
                    <a data-toggle="collapse" data-parent="#accordionRight" href="#collapseOne" aria-expanded="true"
                       aria-controls="collapseOne">
                        Code prefix
                    </a>
                </h5>
            </div>

            <div id="collapseOne" class="collapse <%- (code_question_answer.c_prefix ? 'show' : '') %>" role="tabpanel"
                 aria-labelledby="headingOne">
                <div class="card-body">
                    <div class="container-fluid">
                    <textarea id="prefix" name="prefix"
                              data-a2-type='ccode'><%- code_question_answer.c_prefix %></textarea>
                    </div>
                </div>
            </div>
        </div>
        <div class="card mb-1">
            <div class="card-header" role="tab" id="headingTwo">
                <h5 class="mb-0">
                    <a data-toggle="collapse" data-parent="#accordionRight" href="#collapseTwo" aria-expanded="true"
                       aria-controls="collapseTwo">
                        Code (main)
                    </a>
                    <% if(programming_languages.length > 1) { %>
                        <div class="form-inline pull-right">
                            <label for="question-answer-programming-language">
                                <small>Language:</small>
                            </label>
                            <select class="form-control-sm" id="question-answer-programming-language"
                                    name="c_question_answer_pl">
                                <% for(let i = 0; i < programming_languages.length; i++) { %>
                                    <option value="<%- programming_languages[i].id %>" <%- programming_languages[i].id === code_question_answer.id_programming_language ? 'selected' : '' %>><%- programming_languages[i].name %></option>
                                <% } %>
                            </select>
                        </div>
                    <% } else { %>
                        <input id="question-answer-programming-language" name="c_question_answer_pl" hidden
                               value="<%- programming_languages[0].id %>">
                    <% } %>
                </h5>
            </div>

            <div id="collapseTwo" class="collapse show" role="tabpanel" aria-labelledby="headingTwo">
                <div class="card-body">
                    <div class="container-fluid">
                    <textarea id="c_answer" name="c_answer"
                              data-a2-type='ccode'><%- code_question_answer.c_source %></textarea>
                    </div>
                </div>
            </div>
        </div>

        <div class="card mb-1">
            <div class="card-header" role="tab" id="headingThree">
                <h5 class="mb-0">
                    <a data-toggle="collapse" data-parent="#accordionRight" href="#collapseThree" aria-expanded="true"
                       aria-controls="collapseThree">
                        Code suffix
                    </a>
                </h5>
            </div>

            <div id="collapseThree" class="collapse <%- (code_question_answer.c_suffix ? 'show' : '') %>" role="tabpanel"
                 aria-labelledby="headingThree">
                <div class="card-body">
                    <div class="container-fluid">
                    <textarea id="suffix" name="suffix" data-a2-type='ccode'
                              style="display: none"><%- code_question_answer.c_suffix %></textarea>
                    </div>
                </div>
            </div>
        </div>
        
        <div class="row">
            <div class="col-6 offset-3 d-flex justify-content-center">
                <button class="btn btn-outline-success runAllC" resultdiv="c_result" target="c_answer"
                    type="submit"
                        id_question="<%= question.id %>" name="runcAll" value="run" id="runAllC">
                        <i class="fas fa-cogs"></i>
                        &nbsp;&nbsp; Run all test-cases &nbsp;&nbsp;
                        <i class="fas fa-cogs"></i>
                </button>
            </div>
            <div class="col-3 d-flex justify-content-end">
                <label class="form-check-label">
                    <input class="checkbox-inline" edgar-user-prop="1" type="checkbox" id="chkMarkWhitespace"
                           name="markWhitespace" value="true" data-toggle="toggle"
                            <%= ((session.AppUserSettings && session.AppUserSettings.markWhitespace == 'true') ? "checked" : "") %> >
                    Mark Whitespace
                </label>
                
            </div>

        </div>
        <div id="c_result" class="container-fluid sql_result"></div>
    </div>

    <div class="row card-body card mt-3" id="accordionTestCases" role="tablist">
        <div class="row d-flex justify-content-between">
            <h4>Test items (count = <%= code_question_tests.length %>)</h4>
            <div><a href="javascript:void(0)" class="toggle-accordion"
                accordion-id="#accordionTestCases">Collapse All</a>
            </div>
        </div>
        <% for(var i = 0; i < code_question_tests.length; ++i) { %>
            <input name="c_question_test_id<%= i %>" value="<%= code_question_tests[i].id %>" type="hidden">

            <ul class="nav nav-tabs mt-2" id="testTab<%= i %>" role="tablist">
                <li class="nav-item">
                    <a class="nav-link active" id="test-tab" data-toggle="tab" href="#test<%= i %>" role="tab"
                       aria-controls="test<%= i %>" aria-selected="true">Test item <%= i+1 %></a>
                </li>
                <% if(show_rtc) { %>
                    <li class="nav-item">
                        <a class="nav-link" id="constraints-tab" data-toggle="tab" href="#constraints<%= i %>"
                           role="tab"
                           aria-controls="constraints<%= i %>" aria-selected="false">
                            <% let hasTestRtcOverride = code_question_tests_rtc.filter(item => item.c_question_test_id === code_question_tests[i].id).map(item => item.override_level).includes('test') %>
                            <span>
                                Constraints for test item <%= i+1 %>
                                <% if(hasTestRtcOverride) { %>
                                    <i class="fas fa-exclamation fa-sm" style="margin-left: 5px"></i>
                                <% } %>
                            </span>
                        </a>
                    </li>
                <% } %>
            </ul>
            <div class="tab-content" id=testTabContent<%= i %>">
                <div class="tab-pane fade show active" id="test<%= i %>" role="tabpanel" aria-labelledby="test-tab">

                    <div class="card mt-2 ml-2" id="answer<%= i %>">
                        <div class="card-header" role="tab" id="heading<%= i %>">
                            <div class="d-flex justify-content-between">
                                <div class="d-flex justify-content-start align-items-center">
                                    <a data-toggle="collapse" data-parent="#accordion" href="#collapse<%= i %>"
                                        aria-expanded="false">
                                        Toggle #<%= (i + 1) %>
                                    </a>
                                    <div class="d-flex ml-5 align-items-baseline">
                                        <label style="flex-shrink: 0;"
                                            title="this stands for how many points will be DEDUCTED. If these percentages add up to more than 100% they are reduced to 100%.">Deduct(%) when incorrect: </label>
                                        <input style="max-width: 6rem;" id="percent<%= i %>" name="percent<%= i %>" class="form-control"
                                        value=<%= code_question_tests[i].percentage %>>
                                    </div>
                                    <div class="ml-2"> 
                                        <button type="button" onclick="toggleTestcaseVisiblity(this, '<%= code_question_tests[i].id %>')" class="btn btn-light">
                                                <i title="<%- (code_question_tests[i].is_public === true) ? 'Public test case' : 'Private test case'%>" class="<%- (code_question_tests[i].is_public === true) ? 'fas fa-eye' : 'fas fa-eye-slash'%>"></i>
                                        </button>
                                        <input type="checkbox"                                        
                                            name="is_public_<%= code_question_tests[i].id %>"
                                            hidden
                                            id="id_test_case_<%= code_question_tests[i].id %>"
                                            <%- ((code_question_tests[i].is_public === true) ? 'checked' : '') %>
                                            >
                                    </div>
                                </div>
                                <div>                                                                        
                                    <button class="ml-2 btn btn-outline-danger float-right remove"
                                        cQuestionTestId="<%= code_question_tests[i].id %>" question="<%= question.id %>"
                                        target="answer<%= i %>" style="float: right;">Remove
                                    </button>                                    
                                    <button class="btn btn-outline-success float-right test-item-clone ml-2"
                                            name="cloneCodeTest" value="<%= code_question_tests[i].id %>"
                                            cQuestionTestId="<%= code_question_tests[i].id %>" question="<%= question.id %>"
                                            target="answer<%= i %>" style="float: right;">Clone
                                    </button>
                                </div>
                                
                            </div>
                        </div>

                        <div id="collapse<%= i %>" class="collapse show" role="tabpanel"
                             aria-labelledby="heading<%= i %>">
                            <div class="card-body">
                            
                                <div class="row">
                                    <div class="col-2">
                                        <h6>1. Type</h6>
                                        <hr>
                                        
                                        <div class="form-check form-check-inline ">
                                            <label class="form-check-label">
                                                <input class="form-check-input id_test_type" type="radio"
                                                    name="id_test_type<%= i %>"
                                                    id="id_test_type1<%= i %>" value="1" targetshow="fixed<%= i %>"
                                                    targethide="random<%= i %>,generator<%= i %>" <%= ((code_question_tests[i].c_test_type_id == 1) ? "checked" : "") %> >1.
                                                Fixed
                                            </label>
                                        </div>
                                        <div class="form-check form-check-inline">
                                            <label class="form-check-label">
                                                <input class="form-check-input id_test_type" type="radio"
                                                    name="id_test_type<%= i %>"
                                                    id="id_test_type2<%= i %>" value="2" targetshow="random<%= i %>"
                                                    targethide="fixed<%= i %>,generator<%= i %>" <%= ((code_question_tests[i].c_test_type_id == 2) ? "checked" : "") %>>2.
                                                Random
                                            </label>
                                        </div>
                                        
                                    </div>
                                    <div class="col-6 border-left" >
                                        <h6>2. Settings</h6>
                                        <hr>
                                        <div>

                                            <div class="row fixed<%= i %>"
                                                    style="display: <%= code_question_tests[i].c_test_type_id == '1' ? "" : 'none' %>">
                                                <div class=" col-12 ">
                                                    Input
                                                    <div class="container-fluid">
                                        <textarea id="c_input<%= i %>" name="c_input<%= i %>"
                                                    data-a2-type='text'><%- code_question_tests[i].input %></textarea>
                                                    </div>
                                                </div>
                                                <div class=" col-12 ">
                                                    Output
                                                    <div class="container-fluid">
                                        <textarea id="c_otput<%= i %>" name="c_output<%= i %>"
                                                    data-a2-type='text'><%- code_question_tests[i].output %></textarea>
                                                    </div>
                                                    <!-- <span title="This is a feture and not a bug, still use at you own risk..."><i>*If left empty will be evaluated against teacher's code output.</i></span> -->
                                                </div>
                                            </div>
    
                                            <div class="row random<%= i %>"
                                                    style="display: <%= code_question_tests[i].c_test_type_id == '2' ? "" : 'none' %>">
                                                <div class="container-fluid row">
                                                    <div class="col-8">
                                                        <label>Generator type</label>
                                                        <select name="randGenType<%= i %>" id="randGenType<%= i %>"
                                                                class="randGenType form-control"
                                                                targetlow="low<%= i %>" targetup="up<%= i %>"
                                                                targetnmb="nmb<%= i %>">
                                                            <option value="1" <%= code_question_tests[i].random_test_type_id == '1' ? 'selected' : '' %>>
                                                                integer - number
                                                            </option>
                                                            <option value="2" <%= code_question_tests[i].random_test_type_id == '2' ? 'selected' : '' %>>
                                                                float - number
                                                            </option>
                                                            <option value="3" <%= code_question_tests[i].random_test_type_id == '3' ? 'selected' : '' %>>
                                                                fixed & alpha - text
                                                            </option>
                                                            <option value="4" <%= code_question_tests[i].random_test_type_id == '4' ? 'selected' : '' %>>
                                                                fixed & all printable - text
                                                            </option>
                                                            <option value="5" <%= code_question_tests[i].random_test_type_id == '5' ? 'selected' : '' %>>
                                                                range & alpha - text
                                                            </option>
                                                            <option value="6" <%= code_question_tests[i].random_test_type_id == '6' ? 'selected' : '' %>>
                                                                range & all printable - text
                                                            </option>
                                                        </select>
    
                                                        <p style="font-size: small;"> - for 'range' in text : Number of
                                                            characters
                                                            will be a
                                                            random number between boundaries</p>
    
                                                    </div>
                                                    <div class="col-4">
                                                        <button class="btn btn-outline-success"
                                                                resultdiv="rand_result<%= i %>"
                                                                randType="randGenType<%= i %>" low="lowBound<%= i %>"
                                                                up="upperBound<%= i %>" count="count<%= i %>" type="submit"
                                                                id_question="<%= question.id %>" name="tryRand" value="run">
                                                            Try
                                                            generator
                                                        </button>
                                                    </div>
                                                    <div class="col-12">
                                                        <div class="form-inline" id="low<%= i %>"
                                                                style="display: <%= code_question_tests[i].random_test_type_id != '3' && code_question_tests[i].random_test_type_id != '4' ? "" : 'none' %>">
                                                            <label>Lower bound</label>
    
                                                            <input type="number" name="lowBound<%= i %>"
                                                                    id="lowBound<%= i %>"
                                                                    step="0.01"
                                                                    class="form-control ml-2"
                                                                    value=<%- code_question_tests[i].low_bound %>>
                                                        </div>
    
                                                        <div class="form-inline" id="up<%= i %>"
                                                                style="display: <%= code_question_tests[i].random_test_type_id != '3' && code_question_tests[i].random_test_type_id != '4' ? "" : 'none' %>">
                                                            <label>Upper bound</label>
                                                            <input type="number" name="upperBound<%= i %>"
                                                                    id="upperBound<%= i %>"
                                                                    step="0.01"
                                                                    class="form-control ml-2"
                                                                    value=<%- code_question_tests[i].upper_bound %>>
                                                        </div>
    
                                                        <div class="form-inline" id="nmb<%= i %>"
                                                                style="display: <%= code_question_tests[i].random_test_type_id != '5' && code_question_tests[i].random_test_type_id != '6' ? "" : 'none' %>">
                                                            <label>Number of elements</label>
                                                            <input type="number" name="count<%= i %>" id="count<%= i %>"
                                                                    min="0"
                                                                    class="form-control ml-2"
                                                                    value=<%- code_question_tests[i].elem_count %>>
                                                        </div>
                                                    </div>
                                                    <div class="col-12 CodeMirror" id="rand_result<%= i %>">
    
                                                    </div>
                                                </div>
                                            </div>
    
                                            <div class="row container-fluid card-body card generator<%= i %>"
                                                    style="display: <%= code_question_tests[i].c_test_type_id == '3' ? "" : 'none' %>">
                                                <div class="container-fluid row">
    
                                                    <div class="col-2">
                                                        <label>Select generator</label>
                                                        <select name="generators<%= i %>">
                                                            <option value="1" <%= code_question_tests[i].generator_test_file_id == '1' ? 'selected' : '' %>>
                                                                Slavko
                                                            </option>
                                                            <option value="2" <%= code_question_tests[i].generator_test_file_id == '2' ? 'selected' : '' %>>
                                                                R2D2
                                                            </option>
                                                            <option value="3" <%= code_question_tests[i].generator_test_file_id == '3' ? 'selected' : '' %>>
                                                                C3P0
                                                            </option>
                                                        </select>
    
                                                        <p style="font-size:small;">
                                                            <%- code_question_tests[i].description %>
                                                        </p>
                                                    </div>
                                                    <div class="col-10">
    
                                                        <label>Arguments for generator: </label>
    
                                                        <textarea id="params<%= i %>" name="params<%= i %>"
                                                                    data-a2-type='text'><%- code_question_tests[i].arguments %></textarea>
                                                    </div>
    
                                                </div>
    
                                                <div class="container-fluid text-right">
                                                    <button class="btn btn-outline-success" resultdiv="c_result"
                                                            target="prefix,c_answer,suffix" type="submit"
                                                            id_question="<%= question.id %>"
                                                            name="runc" value="run">Run without input
                                                    </button>
                                                </div>
                                            </div>
    
                                        </div>                                            
                                    </div>
                                    <div class="col-4 border-left">
                                        <h6>3. Grading options</h6>
                                        <hr/>                                        
                                        <div class="row">
                                            <div class=" col-12">
                                                <div class="form-inline">
                                                    <label class="form-check-label">
                                                        <input class="form-check-input" type="checkbox"
                                                                id="diff_order<%= i %>"
                                                                name="diff_order<%= i %>" <%= ((code_question_tests[i].allow_diff_order)
                                                                ? "checked" : "") %>> Allow different elements order
                                                        (NOT
                                                        TESTED)
                                                    </label>
                                                </div>
                                                <div class="form-inline">
                                                    <label class="form-check-label">
                                                        <input class="form-check-input" type="checkbox"
                                                                id="check_letters<%= i %>"
                                                                name="check_letters<%= i %>" <%= ((code_question_tests[i].allow_diff_letter_size)
                                                                ? "checked" : "") %>> Case insensitive
                                                    </label>
                                                </div>
                                                <div class="form-inline">
                                                    <label class="form-check-label">
                                                        <input class="form-check-input" type="checkbox"
                                                                id="trim_whitespace<%= i %>"
                                                                name="trim_whitespace<%= i %>" <%= ((code_question_tests[i].trim_whitespace)
                                                                ? "checked" : "") %>> Trim trailing whitespaces
                                                    </label>
                                                </div>
                                                <hr>
                                                <div class="form-inline">
                                                    <label>Regular expression (overrides/ignores the former three
                                                        options): </label>
                                                    <input id="regex_override<%= i %>" name="regex_override<%= i %>" class="form-control"
                                                            value=<%= code_question_tests[i].regex_override %>>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                
                                <div class="row mt-2 border-top d-flex">
                                    <div class="ml-2">Comment</div>
                                    <div class="ml-2 container-fluid">
                                        <textarea id="comment<%= i %>" name="comment<%= i %>" data-a2-type='text'><%- code_question_tests[i].comment %></textarea>
                                    </div>
                                </div>
                                

                            </div>
                        </div>

                    </div>
                </div>
                <% if(show_rtc) { %>
                    <div class="tab-pane fade" id="constraints<%= i %>" role="tabpanel"
                         aria-labelledby="constraints-tab">
                        <div class="card" id="constraint<%= i %>">
                            <div class="card-header" role="tab" id="constraints-heading<%= i %>">
                                <h5 class="mb-0">
                                    <a data-toggle="collapse" data-parent="#accordion"
                                       href="#collapse-constraints<%= i %>"
                                       aria-expanded="false">
                                        Constraints #
                                        <%= (i + 1) %>
                                    </a>
                                </h5>
                            </div>

                            <div id="collapse-constraints<%= i %>" class="collapse show" role="tabpanel"
                                 aria-labelledby="constraints-heading<%= i %>">
                                <ul class="nav nav-tabs" id="test-constraints-tab-<%- i %>" role="tablist">
                                    <% for(let j = 0; j < programming_languages.length; j++) { %>
                                        <li class="nav-item" style="display:inline-block;">
                                            <a class="nav-link <%- (j === 0) ? 'active' : '' %>"
                                               id="test-constraints-tab-<%- i %>-<%= programming_languages[j].id %>"
                                               data-toggle="tab"
                                               href="#test-constraints-panel-<%- i %>-<%= programming_languages[j].id %>"
                                               role="tab"
                                               aria-controls="test-constraints-panel-<%- i %>-<%= programming_languages[j].id %>"
                                               aria-selected="true">
                                                <% let hasTestLanguageRtcOverride = code_question_tests_rtc.filter(item => item.c_question_test_id === code_question_tests[i].id && item.programming_language_id === programming_languages[j].id).map(item => item.override_level).includes('test') %>
                                                <span>
                                                <%- programming_languages[j].name %>
                                                <% if(hasTestLanguageRtcOverride) { %>
                                                        <i class="fas fa-exclamation fa-sm" style="margin-left: 5px"></i>
                                                <% } %>
                                                </span>
                                            </a>
                                        </li>
                                    <% } %>
                                </ul>
                                <div class="tab-content" id="test-constraints-tab-content-<%- i %>">
                                    <% for(let j = 0; j < programming_languages.length; j++) { %>
                                        <div class="tab-pane fade collapse <%- (j === 0) ? 'show active' : '' %>"
                                             id="test-constraints-panel-<%- i %>-<%= programming_languages[j].id %>"
                                             role="tabpanel"
                                             aria-labelledby="test-constraints-tab-<%- i %>-<%= programming_languages[j].id %>"
                                             aria-selected="<%- (j === 0) ? 'true' : 'false' %>">
                                            <div class="card-body">
                                                <table class="table table-hover edgar no-dt">
                                                    <thead>
                                                    <tr>
                                                        <th scope="col">#</th>
                                                        <th scope="col">constraint</th>
                                                        <th scope="col">value</th>
                                                        <th scope="col">current value</th>
                                                    </tr>
                                                    </thead>
                                                    <tbody>
                                                    <% let currentLanguageArr = code_question_tests_rtc.filter(item => item.c_question_test_id === code_question_tests[i].id && item.programming_language_id === programming_languages[j].id) %>
                                                    <% for(let k = 0; k < currentLanguageArr.length; k++) { %>
                                                        <tr>
                                                            <th scope="row"><%- (k + 1) %></th>
                                                            <td><%- currentLanguageArr[k].constraint_name %></td>
                                                            <% if(currentLanguageArr[k].j0_unit_type) { %>
                                                                <% if(currentLanguageArr[k].j0_unit_type === 'second') { %>
                                                                    <td><input class="form-control" placeholder="..."
                                                                               type="number" min="0" max="20"
                                                                               step="0.001"
                                                                               name="rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>"
                                                                               value="<%- currentLanguageArr[k].override_level === 'test' ? currentLanguageArr[k].constraint_value : '' %>">
                                                                    </td>
                                                                <% } else if(currentLanguageArr[k].j0_unit_type === 'kilobyte') { %>
                                                                    <td><input class="form-control" placeholder="..."
                                                                               type="number" min="0" max="2000000"
                                                                               step="1"
                                                                               name="rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>"
                                                                               value="<%- currentLanguageArr[k].override_level === 'test' ? currentLanguageArr[k].constraint_value : '' %>">
                                                                    </td>
                                                                <% } %>
                                                            <% } else { %>
                                                                <% if(currentLanguageArr[k].constraint_value === 'true' || currentLanguageArr[k].constraint_value === 'false') { %>
                                                                    <td>
                                                                        <div class="form-check form-check-inline">
                                                                            <input class="form-check-input" type="radio"
                                                                                   name="rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>"
                                                                                   id="input_true_rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>"
                                                                                   value="true"
                                                                                    <%- (currentLanguageArr[k].override_level === 'test' && currentLanguageArr[k].constraint_value === 'true') ? 'checked' : '' %>>
                                                                            <label class="form-check-label"
                                                                                   for="input_true_rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>">true</label>
                                                                        </div>
                                                                        <div class="form-check form-check-inline">
                                                                            <input class="form-check-input" type="radio"
                                                                                   name="rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>"
                                                                                   id="input_false_rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>"
                                                                                   value="false"
                                                                                    <%- (currentLanguageArr[k].override_level === 'test' && currentLanguageArr[k].constraint_value === 'false') ? 'checked' : '' %>>
                                                                            <label class="form-check-label"
                                                                                   for="input_false_rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>">false</label>
                                                                        </div>
                                                                        <div class="form-check form-check-inline">
                                                                            <input class="form-check-input" type="radio"
                                                                                   name="rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>"
                                                                                   id="input_none_rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>"
                                                                                   value=""
                                                                                    <%- (currentLanguageArr[k].override_level !== 'test') ? 'checked' : '' %>>
                                                                            <label class="form-check-label"
                                                                                   for="input_none_rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>">default</label>
                                                                        </div>
                                                                    </td>
                                                                <% } else { %>
                                                                    <td><input class="form-control" placeholder="..."
                                                                               type="number" min="0" max="2000000"
                                                                               step="1"
                                                                               name="rtc_t_<%- currentLanguageArr[k].c_question_test_id %>_lang_<%- programming_languages[j].id %>_constr_<%- currentLanguageArr[k].constraint_id %>">
                                                                    </td>
                                                                <% } %>
                                                            <% } %>
                                                            <td><%- currentLanguageArr[k].constraint_value %> <%- currentLanguageArr[k].j0_unit_type ? currentLanguageArr[k].j0_unit_type + 's' : '' %></td>
                                                        </tr>
                                                    <% } %>
                                                    </tbody>
                                                </table>
                                            </div>
                                        </div>
                                    <% } %>
                                </div>

                            </div>
                        </div>
                    </div>
                <% } %>
            </div>

        <% } %>
        <div class="mt-3">
            <button class="btn btn-outline-success" type="submit" name="addNewCtest"
                edgar_confirm_text="You will lose any unsaved changes if you continue.<br>(as Edgar inserts a new stub test and reloads the page)<br>If you made any changes cancel this operation and first save/inplace them and then add a new test<br>Do you want to continue? "
                value="addNewCtest" style="float: left">Add new test item
            </button>
        </div>
        
    </div>

<% } %>
